
#ifndef _biolibc_h_
#include "biolibc.h"
#endif

typedef struct
{
    char    *desc,
	    *seq,
	    *plus,
	    *qual;
    size_t  desc_array_size,
	    seq_array_size,
	    plus_array_size,
	    qual_array_size,
	    desc_len,
	    seq_len,
	    plus_len,
	    qual_len;
}   bl_fastq_t;

#define BL_FASTQ_INIT           { NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, 0, 0, 0 }

// Must be same as BL_FASTA_LINE_UNLIMITED
#define BL_FASTQ_LINE_UNLIMITED 0

/*
 *  Generated by /home/bacon/scripts/gen-get-set
 *
 *  Accessor macros.  Use these to access structure members from functions
 *  outside the bl_fastq_t class.
 *
 *  These generated macros are not expected to be perfect.  Check and edit
 *  as needed before adding to your code.
 */

#define BL_FASTQ_DESC(ptr)              ((ptr)->desc)
#define BL_FASTQ_DESC_AE(ptr,c)         ((ptr)->desc[c])
#define BL_FASTQ_SEQ(ptr)               ((ptr)->seq)
#define BL_FASTQ_SEQ_AE(ptr,c)          ((ptr)->seq[c])
#define BL_FASTQ_PLUS(ptr)              ((ptr)->plus)
#define BL_FASTQ_PLUS_AE(ptr,c)         ((ptr)->plus[c])
#define BL_FASTQ_QUAL(ptr)              ((ptr)->qual)
#define BL_FASTQ_QUAL_AE(ptr,c)         ((ptr)->qual[c])
#define BL_FASTQ_DESC_ARRAY_SIZE(ptr)   ((ptr)->desc_array_size)
#define BL_FASTQ_SEQ_ARRAY_SIZE(ptr)    ((ptr)->seq_array_size)
#define BL_FASTQ_PLUS_ARRAY_SIZE(ptr)   ((ptr)->plus_array_size)
#define BL_FASTQ_QUAL_ARRAY_SIZE(ptr)   ((ptr)->qual_array_size)
#define BL_FASTQ_DESC_LEN(ptr)          ((ptr)->desc_len)
#define BL_FASTQ_SEQ_LEN(ptr)           ((ptr)->seq_len)
#define BL_FASTQ_PLUS_LEN(ptr)          ((ptr)->plus_len)
#define BL_FASTQ_QUAL_LEN(ptr)          ((ptr)->qual_len)

/*
 *  Generated by /home/bacon/scripts/gen-get-set
 *
 *  Mutator macros for setting with no sanity checking.  Use these to
 *  set structure members from functions outside the bl_fastq_t
 *  class.  These macros perform no data validation.  Hence, they achieve
 *  maximum performance where data are guaranteed correct by other means.
 *  Use the mutator functions (same name as the macro, but lower case)
 *  for more robust code with a small performance penalty.
 *
 *  These generated macros are not expected to be perfect.  Check and edit
 *  as needed before adding to your code.
 */

#define BL_FASTQ_SET_DESC(ptr,val)              ((ptr)->desc = (val))
#define BL_FASTQ_SET_DESC_CPY(ptr,val,array_size) strlcpy((ptr)->desc,val,array_size)
#define BL_FASTQ_SET_DESC_AE(ptr,c,val)         ((ptr)->desc[c] = (val))
#define BL_FASTQ_SET_SEQ(ptr,val)               ((ptr)->seq = (val))
#define BL_FASTQ_SET_SEQ_CPY(ptr,val,array_size) strlcpy((ptr)->seq,val,array_size)
#define BL_FASTQ_SET_SEQ_AE(ptr,c,val)          ((ptr)->seq[c] = (val))
#define BL_FASTQ_SET_PLUS(ptr,val)              ((ptr)->plus = (val))
#define BL_FASTQ_SET_PLUS_CPY(ptr,val,array_size) strlcpy((ptr)->plus,val,array_size)
#define BL_FASTQ_SET_PLUS_AE(ptr,c,val)         ((ptr)->plus[c] = (val))
#define BL_FASTQ_SET_QUAL(ptr,val)              ((ptr)->qual = (val))
#define BL_FASTQ_SET_QUAL_CPY(ptr,val,array_size) strlcpy((ptr)->qual,val,array_size)
#define BL_FASTQ_SET_QUAL_AE(ptr,c,val)         ((ptr)->qual[c] = (val))
#define BL_FASTQ_SET_DESC_ARRAY_SIZE(ptr,val)   ((ptr)->desc_array_size = (val))
#define BL_FASTQ_SET_SEQ_ARRAY_SIZE(ptr,val)    ((ptr)->seq_array_size = (val))
#define BL_FASTQ_SET_PLUS_ARRAY_SIZE(ptr,val)   ((ptr)->plus_array_size = (val))
#define BL_FASTQ_SET_QUAL_ARRAY_SIZE(ptr,val)   ((ptr)->qual_array_size = (val))
#define BL_FASTQ_SET_DESC_LEN(ptr,val)          ((ptr)->desc_len = (val))
#define BL_FASTQ_SET_SEQ_LEN(ptr,val)           ((ptr)->seq_len = (val))
#define BL_FASTQ_SET_PLUS_LEN(ptr,val)          ((ptr)->plus_len = (val))
#define BL_FASTQ_SET_QUAL_LEN(ptr,val)          ((ptr)->qual_len = (val))

/* fastq.c */
int bl_fastq_read(FILE *fastq_stream, bl_fastq_t *record);
int bl_fastq_write(FILE *fastq_stream, bl_fastq_t *record, size_t chars_per_line);
void bl_fastq_free(bl_fastq_t *record);
void bl_fastq_init(bl_fastq_t *record);
